<?php
/***************************************************************************
 *                              admin_plus.php
 *                            -------------------
 *   begin                : Thursday, Jul 12, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : sp@phpbb2.de
 *
 *   $Id: admin_board.php,v 1.51.2.6 2003/08/10 00:37:12 stefan2k1 Exp $
 *
 *
 ***************************************************************************/

define('IN_PHPBB', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['Plus']['Configuration'] = "$file";
	return;
}

//
// Let's set the root dir for phpBB
//
$phpbb_root_path = "./../";
require($phpbb_root_path . 'extension.inc');
require('./pagestart.' . $phpEx);

//
// Pull all config data
//
$sql = "SELECT *
	FROM " . PLUS_TABLE;
if(!$result = $db->sql_query($sql))
{
	message_die(CRITICAL_ERROR, "Could not query phpBB2 Plus information in admin_board", "", __LINE__, __FILE__, $sql);
}
else
{
	while( $row = $db->sql_fetchrow($result) )
	{
		$config_name = $row['config_name'];
		$config_value = $row['config_value'];
		$default_config[$config_name] = $config_value;
		
		$new[$config_name] = ( isset($HTTP_POST_VARS[$config_name]) ) ? $HTTP_POST_VARS[$config_name] : $default_config[$config_name];

		if( isset($HTTP_POST_VARS['submit']) )
		{
			$sql = "UPDATE " . PLUS_TABLE . " SET
				config_value = '" . str_replace("\'", "''", $new[$config_name]) . "'
				WHERE config_name = '$config_name'";
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, "Failed to update Plus configuration for $config_name", "", __LINE__, __FILE__, $sql);
			}
		}
	}

	if( isset($HTTP_POST_VARS['submit']) )
	{
		$message = $lang['Config_updated'] . "<br /><br />" . sprintf($lang['Click_return_config'], "<a href=\"" . append_sid("admin_plus.$phpEx") . "\">", "</a>") . "<br /><br />" . sprintf($lang['Click_return_admin_index'], "<a href=\"" . append_sid("index.$phpEx?pane=right") . "\">", "</a>");

		message_die(GENERAL_MESSAGE, $message);
	}
}

$plusstyle_1 = ( $new['index_layout'] == PLUSLAYOUT_1 ) ? "checked=\"checked\"" : "";
$plusstyle_2 = ( $new['index_layout'] == PLUSLAYOUT_2 ) ? "checked=\"checked\"" : "";
$plusstyle_3 = ( $new['index_layout'] == PLUSLAYOUT_3 ) ? "checked=\"checked\"" : "";

$default_avatar_yes = ( $new['default_avatar'] ) ? "checked=\"checked\"" : "";
$default_avatar_no = ( !$new['default_avatar'] ) ? "checked=\"checked\"" : "";

$boardstats_yes = ( $new['show_boardstats'] ) ? "checked=\"checked\"" : "";
$boardstats_no = ( !$new['show_boardstats'] ) ? "checked=\"checked\"" : "";

$links_yes = ( $new['show_links'] ) ? "checked=\"checked\"" : "";
$links_no = ( !$new['show_links'] ) ? "checked=\"checked\"" : "";

$quickreply_yes = ( $new['show_quickreply'] ) ? "checked=\"checked\"" : "";
$quickreply_no = ( !$new['show_quickreply'] ) ? "checked=\"checked\"" : "";

$shoutbox_yes = ( $new['show_shoutbox'] ) ? "checked=\"checked\"" : "";
$shoutbox_no = ( !$new['show_shoutbox'] ) ? "checked=\"checked\"" : "";

$lastvisit_yes = ( $new['show_last_visit'] ) ? "checked=\"checked\"" : "";
$lastvisit_no = ( !$new['show_last_visit'] ) ? "checked=\"checked\"" : "";

$contact_mail = $new['contact_email'];

$template->set_filenames(array(
	"body" => "admin/plus_config_body.tpl")
);

$template->assign_vars(array(
	"S_CONFIG_ACTION" => append_sid("admin_plus.$phpEx"),

	"L_YES" => $lang['Yes'],
	"L_NO" => $lang['No'],
	"L_PLUSCONFIG_TITLE" => $lang['General_Plusconfig'],
	"L_PLUSCONFIG_EXPLAIN" => $lang['Plusconfig_explain'],
	"L_INDEX_LAYOUT" => $lang['Index_Layout'],
	"L_PLUSSTYLE_EXPLAIN" => $lang['Plusstyle_explain'],
	"L_PLUSSTYLE1" => $lang['Plusstyle1'],
	"L_PLUSSTYLE1_EXPLAIN" => $lang['Plusstyle1_explain'],
	"L_PLUSSTYLE2" => $lang['Plusstyle2'],
	"L_PLUSSTYLE2_EXPLAIN" => $lang['Plusstyle2_explain'],
	"L_PLUSSTYLE3" => $lang['Plusstyle3'],
	"L_PLUSSTYLE3_EXPLAIN" => $lang['Plusstyle3_explain'],
	"L_ENABLE_DEFAULTAVATAR" => $lang['Enable_defaultavatar'],
	"L_DEFAULTAVATAR_EXPLAIN" => $lang['Defaultavatar_explain'],
	"L_BOARDSTATS_EXPLAIN" => $lang['Boardstats_explain'],
	"L_ENABLE_LINKS" => $lang['Enable_indexlinks'],
	"L_LINKS_EXPLAIN" => $lang['Indexlinks_explain'],
	"L_ENABLE_QUICKREPLY" => $lang['Enable_quickreply'],
	"L_QUICKREPLY_EXPLAIN" => $lang['Quickreply_explain'],
	"L_ENABLE_SHOUTBOX" => $lang['Enable_shoutbox'],
	"L_SHOUTBOX_EXPLAIN" => $lang['Shoutbox_explain'],
	"L_SUBMIT" => $lang['Submit'], 
	"L_RESET" => $lang['Reset'], 
	"L_PLUS_SETTINGS" => $lang['Plus_Settings'],
	"L_CONTACT_CONFIG" => $lang['Contact_Config'],
	"L_CONTACT_EXPLAIN" => $lang['Contact_Explain'],
	"L_ENABLE_LASTVISIT" => $lang['Enable_Lastvisit'],
	"L_LASTVISIT_EXPLAIN" => $lang['Lastvisit_explain'],
	
	"PLUSSTYLE_1" => PLUSLAYOUT_1, 
	"PLUSSTYLE_1_CHECKED" => $plusstyle_1,
	"PLUSSTYLE_2" => PLUSLAYOUT_2, 
	"PLUSSTYLE_2_CHECKED" => $plusstyle_2,
	"PLUSSTYLE_3" => PLUSLAYOUT_3, 
	"PLUSSTYLE_3_CHECKED" => $plusstyle_3, 
	
	"DEFAULT_AVATAR_YES" => $default_avatar_yes,
	"DEFAULT_AVATAR_NO" => $default_avatar_no,
	"BOARDSTATS_YES" => $boardstats_yes,
	"BOARDSTATS_NO" => $boardstats_no,
	"LINKS_YES" => $links_yes,
	"LINKS_NO" => $links_no,
	"QUICKREPLY_YES" => $quickreply_yes,
	"QUICKREPLY_NO" => $quickreply_no,
	"SHOUTBOX_YES" => $shoutbox_yes,
	"SHOUTBOX_NO" => $shoutbox_no,
	"LASTVISIT_YES" => $lastvisit_yes,
	"LASTVISIT_NO" => $lastvisit_no,
	"CONTACT_MAIL" => $contact_mail,
	"ACTIVATION_NONE_CHECKED" => $activation_none)
);

$template->pparse("body");

include('./page_footer_admin.'.$phpEx);

?>
