<?php

// this functions code is based on the SP mod by CLowN
function album_get_last_pic_info($cats, &$last_pic_id) 
{
    global $phpEx, $board_config, $lang, $db, $album_tree, $album_config;

	$categories = implode(",", $cats);
	
	$this = isset($album_tree['keys'][$cats[0]]) ? $album_tree['keys'][$cats[0]] : -1; 
	$cat = $album_tree['data'][$this];
	
    // Check Pic Approval
	// the cat data array should be the 'current' category...
    if (($cat['cat_approval'] == ALBUM_ADMIN) or ($cat['cat_approval'] == ALBUM_MOD)) 
        $pic_approval_sql = 'AND p.pic_approval = 1'; // Pic Approval ON
	else 
        $pic_approval_sql = ''; // Pic Approval OFF
	
    // OK, we may do a query now... get last picture information
	$sql = "SELECT p.pic_id, p.pic_title, p.pic_user_id, p.pic_username, p.pic_time, p.pic_cat_id, u.user_id, u.username
			FROM " . ALBUM_TABLE . " AS p
				LEFT JOIN " . USERS_TABLE . " AS u  ON p.pic_user_id = u.user_id 
			WHERE p.pic_cat_id IN (" . $categories  .") $pic_approval_sql
			GROUP BY p.pic_time
			ORDER BY p.pic_time DESC
			LIMIT 1";	
    
	if (!$result = $db->sql_query($sql)) 
	{
        message_die(GENERAL_ERROR, 'Could not get last pic information', '', __LINE__, __FILE__, $sql);
    } 

	//if (intval($pic_row['pic_id']) == 0)
	if ($db->sql_numrows($result) == 0)
	{
		$last_pic_id = 0;
		return '';
	}

    $row = $db->sql_fetchrow($result); 

    // Write the Date
    $info = create_date($board_config['default_dateformat'], $row['pic_time'], $board_config['board_timezone']);
    $info .= '<br />';
	
    // Write username of last poster
    if (($row['user_id'] == ALBUM_GUEST) or ($row['username'] == '')) {
        $info .= ($row['pic_username'] == '') ? $lang['Guest'] : $row['pic_username'];
    } else {
        $info .= $lang['Poster'] . ': <a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $row['user_id']) . '">' . $row['username'] . '</a>';
    } 

    // Write the last pic's title. Truncate it if it's too long
    if (!isset($album_config['last_pic_title_length'])) 
		$album_config['last_pic_title_length'] = 25;
    
	$row['pic_title'] = $row['pic_title'];
    
	if (strlen($row['pic_title']) > $album_config['last_pic_title_length']) 
		$row['pic_title'] = substr($row['pic_title'], 0, $album_config['last_pic_title_length']) . '...';

    $info .= '<br />' . $lang['Pic_Title'] . ': <a href="';
    $info .= ($album_config['fullpic_popup']) ? append_sid("album_pic.$phpEx?pic_id=" . $row['pic_id']) . '" target="_blank">' : append_sid("album_showpage.$phpEx?pic_id=" . $row['pic_id']) . '">' ;
    $info .= $row['pic_title'] . '</a>'; 
	
	$last_pic_id = $row['pic_id'];
	
	return $info;
}

// this functions code is based on the mod by CLowN
function album_get_last_comment_info($cats) {
    global $phpEx, $board_config, $lang, $db, $album_tree;

	$categories = implode(",", $cats);
	
	// get last comment information, and user, comment and pic informations
    $sql = "SELECT c.comment_pic_id, c.comment_user_id, c.comment_username, c.comment_time, u.user_id, u.username, a.pic_id, a.pic_cat_id, a.pic_title
			FROM " . ALBUM_COMMENT_TABLE . " AS c 
				LEFT JOIN " . USERS_TABLE . " AS u ON c.comment_user_id = u.user_id
				LEFT JOIN " . ALBUM_TABLE . " AS a ON c.comment_pic_id = a.pic_id
			WHERE a.pic_cat_id IN (" . $categories  .") 
			GROUP BY c.comment_pic_id
			ORDER BY c.comment_time DESC
			LIMIT 1";
				
    if (!$result = $db->sql_query($sql)) 
	{
        message_die(GENERAL_ERROR, 'Could not get last comment information', '', __LINE__, __FILE__, $sql);
    } 
	
	if ($db->sql_numrows($result) == 0)
	{
		return ''; //$lang['No_Comment_Info'];
    }

    $row = $db->sql_fetchrow($result); 
	
	$info = create_date($board_config['default_dateformat'], $row['comment_time'], $board_config['board_timezone']);
    $info .= '<br />' . $lang['Poster'] . ': ';

	if (($row['user_id'] == ALBUM_GUEST) or ($row['comment_username'] == ''))
		$info .= ($row['comment_username'] == '') ? $lang['Guest'] : $row['comment_username'];
	else
		$info .= '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . '=' . $row['user_id']) . '">' . $row['username'] . '</a>';
			
	$info .= '<br />' . $lang['Pic_Title'] . ': <a href="' . append_sid("album_showpage.$phpEx?pic_id=" . $row['pic_id']) . '">' . $row['pic_title'] . '</a>';
	
	return $info;
}

// build the album index table, shown on album.php and album_cat.php
// NOTICE : this code containt alot of unused code, leave it, it's there 
// to help debugging this function, which might not work 100% but oly 99.9%
function album_build_index($cur = 'Root', $real_level = -1, $max_level = -1, &$keys, $show_header = false, $show_public_footer = false) 
{
    global $template, $phpEx, $board_config, $lang, $db, $userdata, $album_tree, $links, $link, $album_config; 

    // init
    $template->set_filenames(array('album' => 'album_box.tpl'));

    $display = false;
    $moderators = '';
    $last_pic_info = '';
    $cat_total_comments = 0;
	
    // display the level
    $this = isset($album_tree['keys'][$cur]) ? $album_tree['keys'][$cur] : -1; 
    
	// root level head
    if ($real_level == -1) 
	{
        // get max inc level
        $keys = array();
        $keys = album_get_auth_keys($cur, true, -1, -1);
        $max_level = album_get_max_depth($cur, false, $keys);
    } 

	// get the level
    $level = $keys['level'][$keys['keys'][$cur]]; 

	// if 'top level category, the write the link to it
    if ($level == 0) 
	{
		$links = '';
		$total_pics = 0;
	 	$last_pic_id = 0;		
		$sub_total_pics = 0;		
		$total_comments = 0;
		
        // display a cat row
        $cat = $album_tree['data'][$this];
        $cat_id = $album_tree['id'][$this]; 

		// sub categories for current category		
	    $cats = array();
		$cats[] = ($level < 0) ? 0 : $cat['cat_id'];
        			
        // specific to the data type
        $title = album_get_object_lang($cur, 'name');
        $desc = album_get_object_lang($cur, 'desc'); 
		
		// get all the cat id for current cat and it's subs, $cats will hold all the ids
		album_get_sub_cat_ids($cur, $cats);		
		
		// get sub-levels		
		// we got the cat_id, we now need to get the value for the next sub category for this category	
        for ($j = 0; $j < count($album_tree['sub'][$cur]); $j++) {
			// get the 'cur' for the current sub category
            $wcur = $album_tree['sub'][$cur][$j];
			// get the keys for current iterated sub level
            $wthis = $album_tree['keys'][$wcur]; 
			// get the row data for current iterated sub level      
            $wdata = $album_tree['data'][$wthis]; 
						
			// get the name of the category
			$wname = album_get_object_lang($wcur, 'name');
			// get the description of the category
            $wdesc = album_get_object_lang($wcur, 'desc');
            $wpgm = append_sid("album_cat.$phpEx?cat_id=" . $album_tree['id'][$wthis]);

			// the number of picture for the sub category (only one level down)
			$sub_cats = array();
			// always include current sub category id
			$sub_cats[] = $album_tree['id'][$wthis];
			// get the all the sub category ids for this sub category
			album_get_sub_cat_ids($wcur, $sub_cats);
			// get the number of pictures in current sub category and its sub categories
			$sub_total_pics = album_get_total_pics($sub_cats);
			
			// are they any pictures in the current category ?
			// then display it after the category name (only sub)
            $sub_total_pics = ($sub_total_pics > 0) ? ' (' . $sub_total_pics . ' ' . $lang['Sub_Total_Pics'] . ')' : '';

            $link = '';
            if ($wname != '')
                $link = '<a href="' . $wpgm . '" title="' . $wdesc . '" class="gensmall">' . $wname . '</a>' . $sub_total_pics;

            if ($link != '')
			{
				if ($album_config['line_break_subcats'] == 1) 
					$links .= '<br>&nbsp;&nbsp;' .$link;
				else
					$links .= ($links != '') ? ', ' . $link : $link;
			}		
        }

		/* if we are showing sub categories, and using line break in it then 'termintate' so it lokos nice */
		if ($links != '' && $album_config['line_break_subcats'] == 1) 
			$links .= '<br>';

		// is there a moderator gropy for this category ?
        if ($cat['cat_moderator_groups'] != '') {
            $moderators = album_get_moderator_info($cat);            
        }			
		// if we got some moderators AND some sub categories,
		// then make sure the sub categories are on a new line
		if (!empty($links) && $moderators != '') 
			$moderators .= '<BR>';
			
		$cat_desc = album_get_object_lang($cur, 'desc');
		if ( !empty($cat_desc) && !empty($links) )
		    $cat_desc .= '<BR>';
			
        // send all the data to the template, except for the sub categories links
        $template->assign_block_vars('catmain', array());
        $template->assign_block_vars('catmain.catrow', array(
			'CAT_TITLE' => album_get_object_lang($cur, 'name'),
            'CAT_DESC' => $cat_desc, 
           	'U_VIEWCAT' => append_sid("album_cat.$phpEx?cat_id=$cat_id"),
			
            'L_MODERATORS' => empty($moderators) ? '' : $lang['Moderators'] . ' :',			
            'MODERATORS' => $moderators,
            )
        ); 
				
		if ($album_config['show_index_total_pics'] == 1) {
			// get the total amount of pictures for current category and its sub categories
			$template->assign_block_vars('catmain.catrow.total_pics', array(
				'TOTAL_PICS' => album_get_total_pics($cats)
				)
			);			
		}
									
		if ($album_config['show_index_total_comments'] == 1) {
			// the total number of comments  for current category and its sub categories
			$template->assign_block_vars('catmain.catrow.total_comments', array(
				'TOTAL_COMMENTS' => album_get_comment_count($cats)
				)
			);			
		}
		
		if ($album_config['show_index_pics'] == 1) {
			$template->assign_block_vars('catmain.catrow.pics', array(
                'PICS' => $cat['count'],
				)
			);			
		}		
		
		if ($album_config['show_index_comments'] == 1) {
			$cat_total_comments = album_get_comment_count($cat_id);	
			$template->assign_block_vars('catmain.catrow.comments', array(
                'COMMENTS' => empty($cat_total_comments) ? 0 : $cat_total_comments
				)
			);			
		}								

		if ($album_config['show_index_last_comment'] == 1) {
			$last_comment_info = album_get_last_comment_info($cats);
			$template->assign_block_vars('catmain.catrow.last_comment', array(
                'LAST_COMMENT_INFO' => empty($last_comment_info) ? $lang['No_Comment_Info'] : $last_comment_info
				)
			);			
		}

		if ($album_config['show_index_last_pic'] == 1) {
			// get the last picture information and the last comment information
			$last_pic_info = album_get_last_pic_info($cats, $last_pic_id);
			$template->assign_block_vars('catmain.catrow.last_pic', array(
	            'LAST_PIC_INFO' => empty($last_pic_info) ? $lang['No_Pics'] : $last_pic_info
				)
			);			
		}
		
		if ($album_config['show_index_thumb'] == 1) 
		{
			// add the index thumbnail picture to the template
			$pic_url = '&nbsp;';
			
			if (empty($last_pic_info) && $album_config['show_index_last_pic'] == 0)
			{
				$last_pic_info = album_get_last_pic_info($cats, $last_pic_id);
			}
			
			
			if (!empty($last_pic_info)) 
			{			
				$pic_url  = '<a href="';
				$pic_url .= ($album_config['fullpic_popup']==0) ? 'album_showpage.'.$phpEx.'?pic_id=' . $last_pic_id . '">': 'album_pic.'.$phpEx.'?pic_id=' . $last_pic_id . '" target=\'_blank\'>';
				$pic_url .= '<img src="album_thumbnail.'.$phpEx.'?pic_id=' . $last_pic_id . '" border="0" alt="" title=""></a>';
			}
		
			$template->assign_block_vars('catmain.catrow.thumb', array(
				'LAST_PIC_URL' => $pic_url
				)
			);
		}
		
        // add the sub category links row to the template
        if ($album_config['show_index_subcats']==1 && !empty($links)) 
		{
            $template->assign_block_vars('catmain.catrow.subcat_link', array(
				'L_LINKS' 	=> $lang['Album_sub_categories'],
                'LINKS' 	=> $links
                )
            );
        }

        // something displayed, yeah baby
        $display = true;
    }
   	
    // display sibling-levels
    for ($i = 0; $i < count($album_tree['sub'][$cur]); $i++) {
        if (!empty($keys['keys'][$album_tree['sub'][$cur][$i]])) {
            $wdisplay = album_build_index($album_tree['sub'][$cur][$i], $level + 1, $max_level, $keys, false, false, $display_index_thumb);
            if ($wdisplay) $display = true;
        } 
    }
	 
    if ($show_header == true) 
	{
		$table_head_class = "thTop";		
		$header_col_span = 1;
		// create header and send it to template
        $template->assign_block_vars('catheader', array(
			'L_CATEGORY' => $lang['Category'],
            'L_PUBLIC_CATS' => $lang['Public_Categories']
            )
        ); 
		
		if ($album_config['show_index_thumb'] == 1) {
			if ($album_config['show_index_total_pics'] == 0 && 
				$album_config['show_index_total_comments'] == 0 &&
				$album_config['show_index_pics'] == 0 &&
				$album_config['show_index_comments'] == 0 &&
				$album_config['show_index_last_comment'] == 0 &&
				$album_config['show_index_last_pic'] == 0 ) 
			{
			    $table_head_class = "thCornerR";
			}
			
	        $template->assign_block_vars('catheader.thumb', array(
				'L_LAST_PIC_THUMB' => $lang['Last_Index_Thumbnail'],
				'CLASS' => $table_head_class				
				)
			);			
			$header_col_span ++;
		}				

		if ($album_config['show_index_total_pics'] == 1) {
			if ($album_config['show_index_total_comments'] == 0 &&
				$album_config['show_index_pics'] == 0 &&
				$album_config['show_index_comments'] == 0 &&
				$album_config['show_index_last_comment'] == 0 &&
				$album_config['show_index_last_pic'] == 0 ) 
			{
			    $table_head_class = "thCornerR";
			}
			
	        $template->assign_block_vars('catheader.total_pics', array(
				'L_TOTAL_PICS' => $lang['Total_Pics'],
				'CLASS' => $table_head_class				
				)
			);
			$header_col_span ++;			
		}				

		if ($album_config['show_index_total_comments'] == 1) {
			if ($album_config['show_index_pics'] == 0 &&
				$album_config['show_index_comments'] == 0 &&
				$album_config['show_index_last_comment'] == 0 &&
				$album_config['show_index_last_pic'] == 0 ) 
			{
			    $table_head_class = "thCornerR";
			}
			
	        $template->assign_block_vars('catheader.total_comments', array(
				'L_TOTAL_COMMENTS' => $lang['Total_Comments'],
				'CLASS' => $table_head_class				
				)
			);
			$header_col_span ++;			
		}				

		if ($album_config['show_index_pics'] == 1) {
			if ($album_config['show_index_comments'] == 0 &&
				$album_config['show_index_last_comment'] == 0 &&
				$album_config['show_index_last_pic'] == 0 ) 
			{
			    $table_head_class = "thCornerR";
			}
		
	        $template->assign_block_vars('catheader.pics', array(
				'L_PICS' => $lang['Pics'],
				'CLASS' => $table_head_class				
				)
			);
			$header_col_span ++;				
		}	            

		if ($album_config['show_index_comments'] == 1) {
			if ($album_config['show_index_last_comment'] == 0 &&
				$album_config['show_index_last_pic'] == 0 ) 
			{
			    $table_head_class = "thCornerR";
			}
			
	        $template->assign_block_vars('catheader.comments', array(
	            'L_COMMENTS' => $lang['Comments'],
				'CLASS' => $table_head_class				
				)
			);
			$header_col_span ++;				
		}	            

		if ($album_config['show_index_last_comment'] == 1) {
			if ($album_config['show_index_last_pic'] == 0 ) 
			{
			    $table_head_class = "thCornerR";
			}

			$template->assign_block_vars('catheader.last_comment', array(
	            'L_LAST_COMMENT_INFO' => $lang['Last_Comments'],
				'CLASS' => $table_head_class				
				)
			);
			$header_col_span ++;				
		}					
            
		if ($album_config['show_index_last_pic'] == 1) {
	        $template->assign_block_vars('catheader.last_pic', array(
	            'L_LAST_PIC' => $lang['Last_Pic'],
				'CLASS' => "thCornerR"
				)
			);
			$header_col_span ++;				
		}			

		// create header and send it to template
        $template->assign_block_vars('catheader.col_span', array(
			'HEADER_COL_SPAN' => $header_col_span
            )
        );

		// and if we are shoing header, then also show footer
        $template->assign_block_vars('catfooter', array());

		// but we need to specific ly specify if we want to show the public gallery header
        if ($show_public_footer == true) 
		{
            $template->assign_block_vars('catfooter.cat_public_footer', array(
				'U_YOUR_PERSONAL_GALLERY' => append_sid("album_personal.$phpEx?user_id=" . $userdata['user_id']),
                'L_YOUR_PERSONAL_GALLERY' => $lang['Your_Personal_Gallery'],

                'U_USERS_PERSONAL_GALLERIES' => append_sid("album_personal_index.$phpEx"),
                'L_USERS_PERSONAL_GALLERIES' => $lang['Users_Personal_Galleries'],
				'FOOTER_COL_SPAN' => $header_col_span
                )
            );
        } 
    } 
	
    // root level footer
	/*
    if ($real_level <= 0) {
        $template->assign_block_vars('catrow', array());
        $template->assign_block_vars('catrow.tablefoot', array());
    } 
	*/
	
    return $display;
} 

?>
